//AssigningTool.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;
import swarm.collections.ListIndex;

/**
 * A tool to choose the unit to which we have to send an order
 *
 * @author Pietro Terna
 */
public class AssigningTool extends SwarmObjectImpl
{
    /** the list of the normal units existing in our environment*/
    public ListImpl unitList;
    /** the iterator of unitList */
    public ListIndex unitListIndex;
    /** the temporary address of an existing unit */
    public Unit aUnit;

    public AssigningTool (Zone aZone, ListImpl ul)
    {
	super(aZone);

	// the list of the normal units
	unitList=ul;
	// its iterator
	unitListIndex=unitList.listBegin(getZone());

    }


    public void assign(Order firstOrder)
    {
	int i, ii, minWaitingList, minWaitingListPos;
	boolean unitNotFound, applied;

	// normal case
	unitNotFound=true;
	unitListIndex.setOffset(0);

	for (i=0;i<unitList.getCount() && unitNotFound ;i++)
	    {
		aUnit=(Unit)unitListIndex.get();
		if (firstOrder.getNextStep() ==	aUnit.getProductionPhase())
		    unitNotFound=false;

		unitListIndex.next();
	    }

	if(! unitNotFound)
	    aUnit.setWaitingList(firstOrder);
	
        if (unitNotFound)
	    {
		System.out.println(
	     "Internal error attempting to send an order; receiving unit does not exists.");
		System.out.println(
				   "The error arises from order # "
				   +firstOrder.getOrderNumber()+
				   " recipe name "+
				   firstOrder.getRecipeName());
		MyExit.exit(1);
	    }
	}
    
}
